
#include "gamepiece.h"

extern state;
extern GAME_STATE_QUIT;

GamePiece::GamePiece()
{
	this->_color=color(0,0,0);
	this->_pos=coord(0,0);
	this->_dim=dimension(0,0);
	this->_sprite=NULL;
}

GamePiece::GamePiece(coord xy, color rgba)
{
	this->_color=rgba;
	this->_pos=xy;
	this->_dim=dimension(0,0);
	this->_sprite=NULL;
}

GamePiece::GamePiece(coord xy, color rgba, SDL_Surface *surf)
{
	this->_color=rgba;
	this->_pos=xy;
	this->_sprite=surf;
	this->_dim=dimension(this->_sprite->w, this->_sprite->h);
}

void GamePiece::initialize()
{
  SDL_Surface *temp;
  temp = SDL_LoadBMP("images/pacman.bmp");
  SDL_SetColorKey(temp, SDL_SRCCOLORKEY, 0);
  this->_sprite = SDL_DisplayFormatAlpha(temp);
  this->_dim=dimension(this->_sprite->w, this->_sprite->h);
  SDL_SetColorKey(temp, 0, 0);
  SDL_FreeSurface(temp);
}

void GamePiece::display()
{
	SDL_Rect block;
    block.x = this->_pos.x;
    block.y = this->_pos.y;
    SDL_BlitSurface(this->_sprite, NULL, screen, &block);
}
bool GamePiece::collision()
{
	// Modify as children
	return false;
}
void GamePiece::update()
{
}

void GamePiece::processKeys()
{
}