#include <stdlib.h>
#include "config.hpp"
#include "gameloop.hpp"
#include "titlescreen.hpp"
#include "helper.hpp"

int main(int argc, char *argv[])
{
  if ( SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER) < 0 ) {
    fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);

  SDL_Surface *screen;

  screen = SDL_SetVideoMode(SCREEN_COLS, SCREEN_ROWS, 32, SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_HWACCEL);//|SDL_FULLSCREEN);
  if ( screen == NULL ) {
    fprintf(stderr, "Unable to set 640x480 video: %s\n", SDL_GetError());
    exit(1);
  }
  SDL_WM_SetCaption("Pacman Fever", NULL);


  GAME_STATE state = GAME_STATE_TITLE;

  while (state != GAME_STATE_QUIT) {

    switch (state) {

    case GAME_STATE_TITLE:
      state = titleScreen(screen);
      break;

    case GAME_STATE_WIN:
      state = winScreen(screen);
      break;

    case GAME_STATE_LOSE:
      state = loseScreen(screen);
      break;

    case GAME_STATE_PLAY:
      state = gameLoop(screen);
      break;

    default:
      state = GAME_STATE_QUIT;
      break;

    }
  }



  return (0);
}
