#ifndef _FUNCTIONS_H_
#define _FUNCTIONS_H_

void generate()
{
	cout << "Loading Enemies" << endl;

	for(int i=mxPiece; i>1; i--)
	{
		switch(i%3)
		{
		case(0):
			gp[i]=new attacker(coord(000,000));
			gp[i]->setSpeed(i%2*150+300);
			break;
		case(1):
			gp[i]=new crawler(coord(000,000));
			gp[i]->setSpeed(i%2*50+100);
			break;
		case(2):
			gp[i]=new shooter(coord(000,000));
			gp[i]->setSpeed(i%2*75+200);
			break;
		}
		gp[i]->dmg();
		//cout << "Am I alive? " << gp[i]->alive() << endl;
	}
	unsigned long int cur=SDL_GetTicks();
	gp[1]=new player(coord(400,400));
	gp[0]=new World(coord(0,0));
}

bool loadCell(int index=-1, string fName="", Uint32 colorkey=0x00001EFF)
{
	if(index==-1 || index>99) return false;
		
	sprite[index] = SDL_LoadBMP(fName.c_str());
	//if(!colorkey) colorkey=SDL_MapRGB( sprite[index]->format, 0, 30, 255);
		SDL_SetColorKey(sprite[index],SDL_SRCCOLORKEY, colorkey);
	sprite[index] = SDL_DisplayFormatAlpha(sprite[index]);

	return true;
}

void loadImages()
{
		//PLAYER IMAGES
		loadCell(CITY, "images/city.bmp");		// 0
		loadCell(UNDERGROUND, "images/underground.bmp");	// 1
		loadCell(BAR,"images/bar.bmp");			// 2
		loadCell(RUN_START,"images/run_start.bmp");	// 3
		loadCell(RUN0,"images/run0.bmp");		// 4
		loadCell(RUN1,"images/run1.bmp");		// 5
		loadCell(RUN2,"images/run2.bmp");		// 6
		loadCell(RUN3,"images/run3.bmp");		// 7
		loadCell(RUN4,"images/run4.bmp");		// 8
		loadCell(RUN5,"images/run5.bmp");		// 9
		loadCell(RUN6,"images/run6.bmp");		// 10
		loadCell(RUN7,"images/run7.bmp");		// 11
		loadCell(RUN8,"images/run8.bmp");		// 12
		loadCell(RUN9,"images/run9.bmp");		// 13
		loadCell(IDLE0,"images/idle0.bmp");		// 14
		loadCell(IDLE1,"images/idle1.bmp");		// 15
		loadCell(JMP_START,"images/jump_start.bmp");
		loadCell(JMP_UP_0,"images/jump_up_0.bmp");
		loadCell(JMP_UP_1,"images/jump_up_1.bmp");
		loadCell(JMP_TOP,"images/jump_top.bmp");
		loadCell(JMP_DWN_0,"images/jump_down_0.bmp");
		loadCell(JMP_DWN_1,"images/jump_down_1.bmp");
		loadCell(JMP_LND_0,"images/jump_land_0.bmp");
		loadCell(JMP_LND_1,"images/jump_land_1.bmp");
		loadCell(SHOOT_0,"images/shoot0.bmp");
		loadCell(SHOOT_1,"images/shoot1.bmp");
		loadCell(SWORD_0,"images/sword0.bmp");
		loadCell(SWORD_1,"images/sword1.bmp");
		loadCell(SWORD_2,"images/sword2.bmp");
		loadCell(SWORD_3,"images/sword3.bmp");
		loadCell(SWORD_4,"images/sword4.bmp");
		loadCell(SWORD_5,"images/sword5.bmp");
		loadCell(SWORD_6,"images/sword6.bmp");
		loadCell(SWORD_7,"images/sword7.bmp");
		loadCell(SWORD_8,"images/sword8.bmp");
		loadCell(SWORD_9,"images/sword9.bmp");
		loadCell(SWORD_10,"images/sword10.bmp");
		loadCell(LADDER_0,"images/ladder0.bmp");
		loadCell(LADDER_1,"images/ladder1.bmp");
		loadCell(JUMPSHOT_0,"images/jump-shot0.bmp");
		loadCell(JUMPSHOT_1,"images/jump-shot1.bmp");
		loadCell(JUMPSHOT_2,"images/jump-shot2.bmp");
		loadCell(JUMPSHOT_3,"images/jump-shot3.bmp");

		//WEAPON SHOT IMAGES
		loadCell(FIREBALL_0,"images/fireball0.bmp",0x0000FFFF);
		loadCell(FIREBALL_1,"images/fireball1.bmp",0x0000FFFF);
		loadCell(FIREBALL_2,"images/fireball2.bmp",0x0000FFFF);
		loadCell(FIREBALL_3,"images/fireball3.bmp",0x0000FFFF);

		//ENEMY ATTACKER0(Link) IMAGES
		loadCell(ATTACKER0_IDLE0,"images/attacker_walk0.bmp",0x0000FFFF); //no idle state so use walk0
		loadCell(ATTACKER0_WALK0,"images/attacker_walk0.bmp",0x0000FFFF);
		loadCell(ATTACKER0_WALK1,"images/attacker_walk1.bmp",0x0000FFFF);
		loadCell(ATTACKER0_WALK2,"images/attacker_walk2.bmp",0x0000FFFF);
		loadCell(ATTACKER0_WALK2,"images/attacker_walk3.bmp",0x0000FFFF);
		loadCell(ATTACKER0_SWORD0,"images/attacker_sword0.bmp",0x0000FFFF);
		loadCell(ATTACKER0_SWORD1,"images/attacker_sword1.bmp",0x0000FFFF);
		loadCell(ATTACKER0_DIE0,"images/attacker_die0.bmp",0x0000FFFF);
		loadCell(ATTACKER0_DIE1,"images/attacker_die1.bmp",0x0000FFFF);
		loadCell(ATTACKER0_DIE2,"images/attacker_die2.bmp",0x0000FFFF);

		//ENEMY CRAWLER0(Mini-boss SMB3) IMAGES
		loadCell(CRAWLER0_IDLE0,"images/crawler_idle0.bmp",0x0000FFFF);
		loadCell(CRAWLER0_RUN_START,"images/crawler_run_start.bmp",0x0000FFFF);
		
		loadCell(CRAWLER0_RUN0,"images/crawler_mywalk0.bmp",0x0000FFFF);
		loadCell(CRAWLER0_RUN1,"images/crawler_idle0.bmp",0x0000FFFF);
		loadCell(CRAWLER0_RUN2,"images/crawler_mywalk2.bmp",0x0000FFFF);

		loadCell(CRAWLER0_ATTACK0,"images/crawler_run0.bmp",0x0000FFFF);
		loadCell(CRAWLER0_ATTACK1,"images/crawler_run1.bmp",0x0000FFFF);
		loadCell(CRAWLER0_ATTACK2,"images/crawler_run2.bmp",0x0000FFFF);
		loadCell(CRAWLER0_ATTACK3,"images/crawler_run3.bmp",0x0000FFFF);
		loadCell(CRAWLER0_ATTACK4,"images/crawler_run4.bmp",0x0000FFFF);

		loadCell(CRAWLER0_DIE0,"images/crawler_die0.bmp",0x0000FFFF);
		loadCell(CRAWLER0_DIE1,"images/crawler_die1.bmp",0x0000FFFF);
		loadCell(CRAWLER0_DIE2,"images/crawler_die2.bmp",0x0000FFFF);

		//ENEMY SHOOTER0(Mario in fire suit) IMAGES
		loadCell(SHOOTER0_IDLE0,"images/shooter_idle0.bmp",0x0000FFFF);
		loadCell(SHOOTER0_WALK0,"images/shooter_walk0.bmp",0x0000FFFF);
		loadCell(SHOOTER0_WALK1,"images/shooter_walk1.bmp",0x0000FFFF);
		loadCell(SHOOTER0_SHOOT0,"images/shooter_shoot0.bmp",0x0000FFFF);
		loadCell(SHOOTER0_SHOOT1,"images/shooter_shoot1.bmp",0x0000FFFF);
		loadCell(SHOOTER0_DIE0,"images/shooter_die0.bmp",0x0000FFFF);

}

void init()
{
	if ( SDL_Init(SDL_INIT_TIMER|SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 ) 
	{
        fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
        exit(1);
    }
    atexit(SDL_Quit);

	
	screen = SDL_SetVideoMode(WIDTH, HEIGHT, 32, SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_HWACCEL);//|SDL_FULLSCREEN);
	if ( screen == NULL ) 
	{
	    fprintf(stderr, "Unable to set 640x480 video: %s\n", SDL_GetError());
	    exit(1);
	}
	SDL_WM_SetCaption("ZombiNES", 0);

	SDL_Init( SDL_INIT_EVERYTHING ); 

	loadImages();

	generate();

}


void mainLoop()
{
	while (state != GAME_STATE_QUIT) 
	{
		switch (state) 
		{

			case GAME_STATE_TITLE:
				//state = titleScreen(screen);
				break;

		    case GAME_STATE_WIN:
				//state = winScreen(screen);
				break;

			case GAME_STATE_LOSE:
				//state = loseScreen(screen);
				break;

			case GAME_STATE_PLAY:
				state = gameLoop();
				break;

			default:
				state = GAME_STATE_QUIT;
				break;
		}
	}
}


#endif