#ifndef _GAMEPIECE_H_
#define _GAMEPIECE_H_


class GamePiece
{
protected:

	int _maxAnimation;
	imgContainer *_animation;
	int *_numFrames;

	int _curAnimation;
	int _curFrame;
	bool _reversed;

	double _height;
	double _targetHeight;
	int _direction;


	unsigned long int animticks;

	bool dead;
public:

	coord _pos;
	VECTOR _speed;

	GamePiece()
	{
		this->initialize();
		this->loadAnimation();
	}
	GamePiece(coord xy)
	{
		this->initialize();
		this->loadAnimation();
		this->_pos=xy;
	}
/*
	GamePiece(coord xy, imgContainer *img)
	{
		initialize();
		loadAnimation(img, 1);
		this->_pos=xy;
	}

	GamePiece(imgContainer *img)
	{
		initialize();
		loadAnimation(img, 1);
	}
*/
	~GamePiece()
	{
		//if(this->copy) return;
		
		//for
	}

	virtual bool loadCell(int state=-1, int index=-1, int imgIndex=-1)
	{
		if(state==-1 || index==-1 || imgIndex==-1) return false;
		
		this->_animation[state].sprite[index] = sprite[imgIndex];

		return true;
	}

	virtual bool loadAnimation()
	{
		return true;
	}

	virtual void initialize()
	{
		this->_reversed=false;
		this->_pos=coord(0,0);
		this->_speed=VECTOR(0,0);
		this->_maxAnimation=0;
		this->_animation=NULL;
		this->_numFrames=NULL;
		this->_curAnimation=0;
		this->_curFrame=0;
		this->animticks=SDL_GetTicks();
		this->_height=0;
		this->_targetHeight=0;
		this->_direction=0;
		this->dead=false;
	}
	virtual void dmg()
	{
		this->dead=true;
		cout << "ouch";
	}
	virtual void live()
	{
		this->dead=false;
		cout << "thats better";
	}
	virtual bool alive()
	{
		return !this->dead;
	}

	virtual void display()
	{
		if(this->_numFrames[this->_curAnimation]<=this->_curFrame)
			this->_curFrame=0;
		SDL_Rect block;
		block.x = this->_pos.x;
		block.y = this->_pos.y+this->_height-this->_animation[this->_curAnimation].sprite[this->_curFrame]->h;
		

		switch(this->_direction)
		{
			case 0:
				SDL_BlitSurface(this->_animation[this->_curAnimation].sprite[this->_curFrame], NULL, screen, &block);
				break;
			case 1:
				SDL_BlitSurface(flip_surface(this->_animation[this->_curAnimation].sprite[this->_curFrame], 0x02 ), NULL, screen, &block);
				break;
			case 2:
				SDL_BlitSurface(flip_surface(this->_animation[this->_curAnimation].sprite[this->_curFrame], 0x01 ), NULL, screen, &block);
				break;
			case 3:
				SDL_BlitSurface(flip_surface(this->_animation[this->_curAnimation].sprite[this->_curFrame], 0x01 | 0x02 ), NULL, screen, &block);
				break;
			default:
				SDL_BlitSurface(this->_animation[this->_curAnimation].sprite[this->_curFrame], NULL, screen, &block);
				break;
		}
	}
	

	virtual bool collision()
	{
		// Modify as children
		return false;
	}
	virtual void update()
	{
		if(this->dead) {cout << "I'm Dead" << endl; return;}

		this->processKeys();
		this->_pos=this->_pos+this->_speed;
		this->collision();
		this->UpdateAnimation();
		this->display();
	}

	virtual void setSpeed(double _tospeed)
	{
		this->_speed.speed=_tospeed;
	}

	virtual void UpdateAnimation()
	{
		if((SDL_GetTicks()-this->animticks)>100)
		{
			this->animticks=SDL_GetTicks();

			if(this->_curFrame<this->_numFrames[this->_curAnimation])
			{
				this->_curFrame++;
			}
			if(this->_curFrame>=this->_numFrames[this->_curAnimation])
			{
				this->_curFrame=1;
			}			
		}
	}

	virtual void move(VECTOR speed)
	{
		this->_pos=this->_pos+speed;
	}

	virtual coord set(coord spot)
	{
		return this->_pos=spot;
	}

	virtual int level()
	{
		return 0;
	}
	
	virtual coord getOffset()
	{
		return coord(0,0);
	}
	virtual void processKeys()
	{
		return;
	}


};

#endif