#include "ghost.hpp"

Ghost::Ghost()
{
  pos_r = 19*20;
  pos_c = 20*20;

  sprite = NULL;
}

Ghost::Ghost(double r, double c)
{
  pos_r = r;
  pos_c = c;

  sprite = NULL;
}

Ghost::~Ghost()
{
  if (sprite != NULL) 
    SDL_FreeSurface(sprite);
}

void Ghost::initialize()
{
  SDL_Surface *temp;
  temp = SDL_LoadBMP("images/ghost.bmp");
  SDL_SetColorKey(temp, SDL_SRCCOLORKEY, 0);
  sprite = SDL_DisplayFormatAlpha(temp);
  SDL_SetColorKey(temp, 0, 0);
  SDL_FreeSurface(temp);
}

void Ghost::update(World &board, Player &pacman)
{
  double posr2, posc2;
  double speed = 1.5;
  if (pos_r > pacman.getRow())
    posr2 = pos_r-speed;
  else if (pos_r < pacman.getRow())
    posr2 = pos_r+speed;
  else
	posr2 = pos_r;

  if (pos_c > pacman.getCol())
    posc2 = pos_c-speed;
  else if (pos_c < pacman.getCol())
    posc2 = pos_c+speed;
  else
	posc2 = pos_c;
      
  if (board.isFree(posr2, posc2)) {
    pos_r = posr2;
    pos_c = posc2;
  }
}

void Ghost::renderSDL(SDL_Surface *screen)
{
    //Draw Ghost
	SDL_Rect block;
    block.x = pos_c;
    block.y = pos_r;
    SDL_BlitSurface(sprite, NULL, screen, &block);
}
