#ifndef _MONSTER_H_
#define _MONSTER_H_

class monster  : public GamePiece
{
public:
	bool stopx;
	bool stopy;
	bool adjust;

	monster()
	{
		this->initialize();
		this->loadAnimation();
	}
	monster(coord xy)
	{
		this->stopx=this->stopx=false;
		this->initialize();
		this->loadAnimation();
		this->_pos=xy;
	}

	virtual void display()
	{
		SDL_Rect block;
		coord TEMP=this->_pos+gp[0]->getOffset();
		if(this->_numFrames[this->_curAnimation]<=this->_curFrame)
			this->_curFrame=0;

		block.x = TEMP.x;
		this->_curAnimation;
		block.y = TEMP.y+this->_height-this->_animation[this->_curAnimation].sprite[this->_curFrame]->h;

		int temp=this->_direction;
		if(Bring_On_The_Hord) temp=0;
		switch(temp)
		{
			case 0:
				SDL_BlitSurface(this->_animation[this->_curAnimation].sprite[this->_curFrame], NULL, screen, &block);
				break;
			case 1:
				SDL_BlitSurface(flip_surface(this->_animation[this->_curAnimation].sprite[this->_curFrame], 0x02 ), NULL, screen, &block);
				break;
			case 2:
				SDL_BlitSurface(flip_surface(this->_animation[this->_curAnimation].sprite[this->_curFrame], 0x01 ), NULL, screen, &block);
				break;
			case 3:
				SDL_BlitSurface(flip_surface(this->_animation[this->_curAnimation].sprite[this->_curFrame], 0x01 | 0x02 ), NULL, screen, &block);
				break;
			default:
				SDL_BlitSurface(this->_animation[this->_curAnimation].sprite[this->_curFrame], NULL, screen, &block);
				break;
		}
	}

	virtual bool loadAnimation()
	{
		this->_maxAnimation=4; //how many animations are there run/jump
		this->_numFrames=new int[this->_maxAnimation]; //number of frames in animation

		this->_numFrames[0]=11;
		this->_numFrames[1]=1;
		this->_numFrames[2]=11;
		this->_numFrames[3]=1;

		this->_animation=new imgContainer[this->_maxAnimation];  
		for(int _state=0; _state<this->_numFrames[_state]; _state++)
		{
			this->_animation[_state].sprite==new SDL_Surface*[this->_numFrames[_state]];
			this->_animation[_state].isCopy=false;
		}

		this->loadCell(0,0,RUN_START);

		this->loadCell(0,1,RUN0);
		this->loadCell(0,2,RUN1);
		this->loadCell(0,3,RUN2);
		this->loadCell(0,4,RUN3);
		this->loadCell(0,5,RUN4);
		this->loadCell(0,6,RUN5);
		this->loadCell(0,7,RUN6);
		this->loadCell(0,8,RUN7);
		this->loadCell(0,9,RUN8);
		this->loadCell(0,10,RUN9);
		
		this->loadCell(1,0,IDLE0);
		this->loadCell(1,1,IDLE1);
		this->loadCell(1,2,IDLE2);

		//this->_animation[0].sprite[0]+1;
		
		//this->_dim=dimension(this->_sprite[0][0]->w, this->_sprite[0][0]->h);
		
		//img->isCopy=false;
		this->_curAnimation=0;
		return true;
	}

	virtual void UpdateAnimation()
	{
		// this probably isn't the best way to do this, but its not my job

		//if(this->stopx && this->stopy)
		//	this->_curAnimation=1;

		if(SDL_GetTicks()-this->animticks>100)
		{
			//cout << this->_curAnimation << " " << this->_curFrame << endl;
			this->animticks=SDL_GetTicks();
			if(this->_curFrame<this->_numFrames[this->_curAnimation])
			{
				this->_curFrame++;
			}
			if(this->_curFrame>=this->_numFrames[this->_curAnimation])
			{
				this->_curFrame=0;
			}			
		}
	}

	virtual void AI()
	{

		if( gp[1]->_pos.x > this->_pos.x+gp[0]->getOffset().x)
		{
			this->_speed.x = this->_speed.speed;
			this->_direction=0;
		}
		else
		{
			this->_speed.x = -this->_speed.speed;
			this->_direction=1;
		}		

		  if (  abs( ( gp[1]->_pos.x - ( this->_pos.x + gp[0]->getOffset().x ) ) ) < 150 )
        {
            if( gp[1]->_pos.y > this->_pos.y)
                this->_speed.y = this->_speed.speed;
            else
                this->_speed.y = -this->_speed.speed;
        }
		  if(gp[1]->_pos.distance(this->_pos+gp[0]->getOffset())<100)
			  this->_curAnimation=3;
		  else
			this->_curAnimation=0;
	}

//might want to check from middle of monster.  as is we are checking the top left corner versus others, so it appears to shift monsters leftwards
//if we do this will have to edit the <15 to something bigger.  this gives a cooler swarm effect.  i played with this as 20/40/60/100 fps.  
//was clean up until 100, then it looked too shakey
	virtual void checkMonster()
	{	
		bool stop=false;

		for(int i=2; i<mxPiece-mxAnimSoFar;i++)
		{
			if(!gp[i]->alive()) continue;
			if(gp[i]!=this && (abs(gp[i]->_pos.x-this->_pos.x)<30) )
			{
				this->stopx=true;
				this->_pos.x += ( this->_pos.x - gp[i]->_pos.x ) / 8;
			}
			else
				this->stopx=false;

			if(gp[i]!=this && (abs(gp[i]->_pos.y-this->_pos.y)<30) )
			{
				this->_pos.y += ( this->_pos.y - gp[i]->_pos.y ) / 8;
				this->stopy=true;
			}
			else
				this->stopy=false;
		}
	}
	
	virtual bool collision()
	{

		
		bool stop=false;

		this->checkMonster();
		//only collision detection should be with the Y upper/lower values.

		//if( gp[1]->_pos.y == this->_pos.y && gp[1]->_pos.x == this->_pos.x )
		
		if( (gp[1]->_pos.distance(this->_pos+gp[0]->getOffset())<35) )
		{
			//this->_pos.x = 400;
			//this->_pos.y = 400;
			stop=true;
			//this->_pos=this->_pos+this->_speed;
		}

		if(!stop)
		{
			this->_pos.x+=this->_speed.x*(double)(SDL_GetTicks()-throttle)/1000;
		}
		if(!stop)
		{
			this->_pos.y+=this->_speed.y*(double)(SDL_GetTicks()-throttle)/1000;
		}

		//checking bottem
		if(this->_pos.y>485)
			this->_pos.y=485;


		//checking top. 
		// CHANGE TO collideWorld() or somthign
		if(gp[0]->level()==0 && this->_pos.y<310)
			this->_pos.y=310;
		else if(gp[0]->level()==1 && this->_pos.y<150)
			this->_pos.y=150;

		return false;
	}

	virtual void update()
	{
		if(this->dead) return;
		this->processKeys();

		this->AI();
		this->collision();

		this->UpdateAnimation();
		this->display();
	}
		

	virtual void processKeys()
	{
		//no key states to process either.  
		return;
	}

};

#endif