#ifndef _GAMEPIECE_H_
#define _GAMEPIECE_H_


class GamePiece
{
protected:

	int _maxAnimation;
	imgContainer *_animation;
	int *_numFrames;

	int _curAnimation;
	int _curFrame;
	bool _reversed;

	

	unsigned long int animticks;

public:

	coord _pos;
	VECTOR _speed;
	SDL_Rect col_box;

	GamePiece()
	{
		this->initialize();
		this->loadAnimation();
	}
	GamePiece(coord xy)
	{
		this->initialize();
		this->loadAnimation();
		this->_pos=xy;
	}
/*
	GamePiece(coord xy, imgContainer *img)
	{
		initialize();
		loadAnimation(img, 1);
		this->_pos=xy;
	}

	GamePiece(imgContainer *img)
	{
		initialize();
		loadAnimation(img, 1);
	}
*/
	~GamePiece()
	{
		//if(this->copy) return;
		
		//for
	}

	virtual bool loadCell(int state=-1, int index=-1, int imgIndex=-1, Uint32 colorkey=0)
	{
		if(state==-1 || index==-1 || imgIndex==-1) return false;
		
		this->_animation[state].sprite[index] = sprite[imgIndex];

		return true;
	}

	virtual bool loadAnimation()
	{
		return true;
	}
/*
	virtual bool loadAnimation(imgContainer img, int mxAnime)
	{
		img->isCopy=true;
		this->copy=true;
		this->_animation=new imgContainer* [this->_maxAnimation];
		for(int i=0; i<1; i++)
		{
			this->_animation[0]=new SDL_Surface[this->numFrames];
		}

		for(int r=0; r<rc.h; r++)
			for(int c=0; c<rc.w; c++)
				this->_sprite=surf;
		this->_dim=dimension(this->_sprite[0][0]->w, this->_sprite[0][0]->h);
	}
*/
	virtual void initialize()
	{
		this->_reversed=false;
		this->_pos=coord(0,0);
		this->_speed=VECTOR(0,0);
		this->_maxAnimation=0;
		this->_animation=NULL;
		this->_numFrames=NULL;
		this->_curAnimation=0;
		this->_curFrame=0;
		this->animticks=SDL_GetTicks();
	}

	virtual void display()
	{
		SDL_Rect block;
		block.x = this->_pos.x;
		block.y = this->_pos.y;
		if(this->_numFrames[this->_curAnimation]<=this->_curFrame)
			this->_curFrame=0;

		SDL_BlitSurface(this->_animation[this->_curAnimation].sprite[this->_curFrame], NULL, screen, &block);
	}

	virtual bool collision()
	{
		// Modify as children
		return false;
	}

	virtual void update()
	{
		this->processKeys();
		this->_pos=this->_pos+this->_speed;
		this->collision();
		this->UpdateAnimation();
		this->display();
	}

	virtual void setSpeed(int _tospeed)
	{
		this->_speed.speed=_tospeed;
	}

	virtual void UpdateAnimation()
	{
		if((SDL_GetTicks()-this->animticks)>100)
		{
			this->animticks=SDL_GetTicks();

			if(this->_curFrame<this->_numFrames[this->_curAnimation])
			{
				this->_curFrame++;
			}
			if(this->_curFrame>=this->_numFrames[this->_curAnimation])
			{
				this->_curFrame=1;
			}			
		}
	}

	virtual void move(VECTOR speed)
	{
		this->_pos=this->_pos+speed;
	}

	virtual coord set(coord spot)
	{
		return this->_pos=spot;
	}

	virtual int level()
	{
		return 0;
	}
	
	virtual coord getOffset()
	{
		return coord(0,0);
	}
	virtual void processKeys()
	{
		return;
	}
};

#endif