#ifndef _MONSTER_H_
#define _MONSTER_H_

class monster  : public GamePiece
{
public:
	bool stopx;
	bool stopy;
	bool adjust;
    coord posArray[4];

	monster()
	{
		this->initialize();
		this->loadAnimation();
		col_box.h =0;
		col_box.w =0;
		col_box.x =0;
		col_box.y =0;

	}
	monster(coord xy)
	{
		stopx = false;
		stopy = false;
		this->initialize();
		this->loadAnimation();
		this->_pos=xy;
		col_box.h =96/4;
		col_box.w =96; 
	}

	virtual void display()
	{
		SDL_Rect block;
		coord TEMP=this->_pos+gp[0]->getOffset();
		if(this->_numFrames[this->_curAnimation]<=this->_curFrame)
			this->_curFrame=0;
		block.x = TEMP.x;
		block.y = TEMP.y;
		SDL_BlitSurface(this->_animation[this->_curAnimation].sprite[this->_curFrame], NULL, screen, &block);
	}

	virtual bool loadAnimation()
	{
		this->_maxAnimation=4; //how many animations are there run/jump
		this->_numFrames=new int[this->_maxAnimation]; //number of frames in animation

		this->_numFrames[0]=11;
		this->_numFrames[1]=1;
		this->_numFrames[2]=11;
		this->_numFrames[3]=1;

		this->_animation=new imgContainer[this->_maxAnimation];  
		for(int _state=0; _state<this->_numFrames[_state]; _state++)
		{
			this->_animation[_state].sprite==new SDL_Surface*[this->_numFrames[_state]];
			this->_animation[_state].isCopy=false;
		}

		this->loadCell(0,0,RUN_START);

		this->loadCell(0,1,RUN0);
		this->loadCell(0,2,RUN1);
		this->loadCell(0,3,RUN2);
		this->loadCell(0,4,RUN3);
		this->loadCell(0,5,RUN4);
		this->loadCell(0,6,RUN5);
		this->loadCell(0,7,RUN6);
		this->loadCell(0,8,RUN7);
		this->loadCell(0,9,RUN8);
		this->loadCell(0,10,RUN9);
		
		this->loadCell(1,0,IDLE0);
		this->loadCell(1,1,IDLE1);
		this->loadCell(1,2,IDLE2);

		this->loadCell(2,0,RUN_START_REV);

		this->loadCell(2,1,RUN0_REV);
		this->loadCell(2,2,RUN1_REV);
		this->loadCell(2,3,RUN2_REV);
		this->loadCell(2,4,RUN3_REV);
		this->loadCell(2,5,RUN4_REV);
		this->loadCell(2,6,RUN5_REV);
		this->loadCell(2,7,RUN6_REV);
		this->loadCell(2,8,RUN7_REV);
		this->loadCell(2,9,RUN8_REV);
		this->loadCell(2,10,RUN9_REV);
		
		this->loadCell(3,0,IDLE0_REV);
		this->loadCell(3,1,IDLE1_REV);
		this->loadCell(3,2,IDLE2_REV);

		//this->_animation[0].sprite[0]+1;
		
		//this->_dim=dimension(this->_sprite[0][0]->w, this->_sprite[0][0]->h);
		
		//img->isCopy=false;
		return true;
	}

	virtual void UpdateAnimation()
	{
		// this probably isn't the best way to do this, but its not my job
		if(this->stopx)
			this->_curAnimation=1+2*this->_reversed;
		else
			this->_curAnimation=0+2*this->_reversed;

		if(SDL_GetTicks()-this->animticks>100)
		{
			this->animticks=SDL_GetTicks();
			if(this->_curFrame<this->_numFrames[this->_curAnimation])
			{
				this->_curFrame++;
			}
			if(this->_curFrame>=this->_numFrames[this->_curAnimation])
			{
				this->_curFrame=1;
			}			
		}
	}

	virtual void AI()
	{

		bool monsterStop = false;
		int dX=gp[1]->_pos.x - ( this->_pos.x + gp[0]->getOffset().x ) ; 
		int dY=gp[1]->_pos.y - ( this->_pos.y );

		if(abs(dX) < 25 && abs(dY) < 25) 
			monsterStop = true;

		if(dY == 0)
			dY = 1;
		if(dX == 0)
			dX = 1 ;
		
		int m = abs ( dX/dY ) ;

		if( m == 0)
			m =1;

		if( gp[1]->_pos.x > this->_pos.x+gp[0]->getOffset().x && !monsterStop)
		{
			this->_speed.x = this->_speed.speed;
			this->_reversed=false;
		}
		else
		if ( !monsterStop)
		{
			this->_speed.x = -this->_speed.speed;
			this->_reversed=true;
		}
		
		if( gp[1]->_pos.y > this->_pos.y)
			this->_speed.y = this->_speed.speed / m;
		else
			this->_speed.y = - (this->_speed.speed / m);

		if (monsterStop)
		{
			this->_speed.x = 0;
			this->_speed.y = 0;
		}	

	}

	virtual bool checkMonster()
	{	
/*		
		//The sides of the rectangles 
		int leftA, leftB; 
		int rightA, rightB; 
		int topA, topB; 
		int bottomA, bottomB; 
		//Calculate the sides of rect A 
		
		SDL_Rect A = this->col_box;
		cout<<"this peice is"<<" ===="<<this->col_box.w<<" "<<this->col_box.h<<" "<<this->col_box.x<<" "<<this->col_box.y<<" "<<endl;

		for(int lcv = mxPiece-mxAnimSoFar; lcv > 1; lcv--)
		{
		if(this==gp[lcv]) 
		{				
			cout<<mxPiece-mxAnimSoFar<<endl;
			continue;
		}
		else 
		{
		cout<<lcv<<" "<<gp[lcv]->col_box.w<<" "<<gp[lcv]->col_box.h<<" "<<gp[lcv]->col_box.x<<" "<<gp[lcv]->col_box.y<<" "<<endl;
		SDL_Rect B = gp[lcv]->col_box;

		leftA = A.x; 
		rightA = A.x + A.w; 
		topA = A.y; 
		bottomA = A.y + A.h; 
		//Calculate the sides of rect B 
		leftB = B.x; 
		rightB = B.x + B.w; 
		topB = B.y; 
		bottomB = B.y + B.h;

		if( bottomA <= topB ) 
		{ 
			return false; 
		} 
		if( topA >= bottomB ) 
		{ 
			return false; 
		} 
		if( rightA <= leftB ) 
		{ 
			return false; 
		} 
		if( leftA >= rightB ) 
		{ 
			return false; 
		}
		}
		}
		//If none of the sides from A are outside B 
		*/

		for(int lcv = mxPiece-mxAnimSoFar; lcv > 1; lcv--)
		{
			//check if direction we are going is occupied.  if not, return false.  if so, move to logical new position
			//and return true

			for( int x = 0; x < 4;x++ )//4 = number of positions we are considering around unit, could change
			{
				//cout<<"origx: "<<this->posArray[x].x<<"`origy: "<<this->posArray[x].y<<" comparx:"<<gp[lcv]->_pos.x<<" compary:"<<gp[lcv]->_pos.y<<endl;
				if( (this->posArray[x].x == gp[lcv]->_pos.x) && (this->posArray[x].y == gp[lcv]->_pos.y) )
			  {	
				if( this->_speed.x < this->_speed.y )
				  this->_pos.x -=this->_speed.x;
				else
				  this->_pos.y -=this->_speed.y;
					return true;
			  }
			}
		}
		
		
		return false; 
	}
	
	virtual bool collision()
	{	

		//       2
		//      1 3
		//     0 X 4 
		//      7 5
		//       6
		//need to add a "buffer" as 1 pixel isn't enough to verify if should move, also, it is checking from where player
		//is drawn
		this->posArray[0].x = this->_pos.x - 1; 
		this->posArray[0].y = this->_pos.y;
		this->posArray[1].x = this->_pos.x + 1; 
		this->posArray[1].y = this->_pos.y;
		this->posArray[2].y = this->_pos.y + 1;
		this->posArray[2].x = this->_pos.x;
		this->posArray[3].y = this->_pos.y - 1;
		this->posArray[3].x = this->_pos.x;

		if( this->checkMonster() )
		{		
		
		}

		/*
		//bool stop=false;


		//this needs to change dynamically based on the image height/width/x/y.  right now arbitraily putting
		//40x2 box in bottem of a 96x96 image
		int old_x = this->_pos.x;
		int old_y = this->_pos.y;
		*/
		this->_pos.x+=this->_speed.x;
		this->_pos.y+=this->_speed.y;
		/*
		this->col_box.w = 10;
		this->col_box.h = 2;
		this->col_box.x = this->_pos.x + gp[0]->getOffset().x;
		this->col_box.y = this->_pos.y + 94;
		
		if ( !this->checkMonster() ) 
			this->_pos.x=old_x;
		
		if ( !this->checkMonster() )//if collision with "desired" direction 
			this->_pos.y=old_y;

		if( this->_speed.x > 0 )

		if( this->_speed.y > 0 )



		if(this->_pos.y>385)
			this->_pos.y=385;

		if(gp[0]->level()==0 && this->_pos.y<210)
			this->_pos.y=210;
		else if(gp[0]->level()==1 && this->_pos.y<50)
			this->_pos.y=50;
*/
		return false;
	}

	virtual void update()
	{
		this->processKeys();

		this->AI();
		this->collision();

		this->UpdateAnimation();
		this->display();
	}
		

	virtual void processKeys()
	{  
		return;
	}
};

#endif