#ifndef _PLAYER_H_
#define _PLAYER_H_

class player  : public GamePiece
{
	bool jump;
	int groundY;
	unsigned long int startJump;
public:

	player()
	{
		this->initialize();
		this->loadAnimation();
	}
	player(coord xy)
	{
		this->jump=false;
		this->startJump=0;
		this->initialize();
		this->loadAnimation();
		this->_pos=xy;
		this->_targetHeight=this->_pos.y;
		//this->groundY=this->_pos.y;
		this->_curAnimation=1;
	}

	virtual bool loadAnimation()
	{
		cout << "Loading Player" << endl;
		this->_maxAnimation=9; //how many animations are there run/jump
		this->_numFrames=new int[this->_maxAnimation]; //number of frames in animation

		this->_numFrames[0]=10;
		this->_numFrames[1]=1;
		this->_numFrames[2]=1;
		this->_numFrames[3]=2;
		this->_numFrames[4]=1;
		this->_numFrames[5]=2;
		this->_numFrames[6]=2;
		this->_numFrames[7]=2;
		this->_numFrames[8]=10;

		this->_animation=new imgContainer[this->_maxAnimation];  
		for(int _state=0; _state<this->_numFrames[_state]; _state++)
		{
			this->_animation[_state].sprite==new SDL_Surface*[this->_numFrames[_state]];
			this->_animation[_state].isCopy=false;
		}

		//this->loadCell(0,0,RUN_START);
		this->loadCell(0,0,RUN0);
		this->loadCell(0,1,RUN1);
		this->loadCell(0,2,RUN2);
		this->loadCell(0,3,RUN3);
		this->loadCell(0,4,RUN4);
		this->loadCell(0,5,RUN5);
		this->loadCell(0,6,RUN6);
		this->loadCell(0,7,RUN7);
		this->loadCell(0,8,RUN8);
		this->loadCell(0,9,RUN9);
		
		this->loadCell(1,0,IDLE0);

		this->loadCell(2,0,JMP_START);

		this->loadCell(3,0,JMP_UP_0);
		this->loadCell(3,1,JMP_UP_1);

		this->loadCell(4,0,JMP_TOP);
		this->loadCell(5,0,JMP_DWN_0);

		this->loadCell(5,1,JMP_DWN_1);

		this->loadCell(6,0,JMP_LND_0);
		this->loadCell(6,1,JMP_LND_1);

		this->loadCell(7,0,IDLE1);
		this->loadCell(7,1,IDLE2);

		this->loadCell(8,0,SWORD_1);
		this->loadCell(8,1,SWORD_2);
		this->loadCell(8,2,SWORD_3);
		this->loadCell(8,3,SWORD_4);
		this->loadCell(8,4,SWORD_5);
		this->loadCell(8,5,SWORD_6);
		this->loadCell(8,6,SWORD_7);
		this->loadCell(8,7,SWORD_8);
		this->loadCell(8,8,SWORD_1);
		this->loadCell(8,9,SWORD_1);

		//this->_animation[0].sprite[0]+1;
		
		//this->_dim=dimension(this->_sprite[0][0]->w, this->_sprite[0][0]->h);
		
		//img->isCopy=false;
		return true;
	}

	
	virtual void UpdateAnimation()
	{
		if((SDL_GetTicks()-this->animticks)>100)
		{
			this->animticks=SDL_GetTicks();

			if(this->_curFrame<this->_numFrames[this->_curAnimation])
			{
				this->_curFrame++;
			}
			if(this->_curFrame>=this->_numFrames[this->_curAnimation])
			{
				if(this->_curAnimation==6)
					this->_curAnimation==1;
				else if(this->_curAnimation==0)
					this->_curFrame=1;
				else if(this->_curAnimation==8 && this->_curFrame==10)
					this->_curAnimation=1;

				this->_curFrame=0;
			}			
		}
	}
	
	virtual bool collision()
	{
		if(jump)
		{
			this->_height=-sin(22/7.0*(SDL_GetTicks()-this->startJump)/1000.0)*this->_targetHeight;
			if(this->_height>=0 && SDL_GetTicks()-this->startJump > 50)
			{
				this->_height=0;
				this->jump=false;
				cout << SDL_GetTicks()-this->startJump << endl;
				this->_curAnimation=6;
			}
			if(SDL_GetTicks()-this->startJump<100)
				this->_curAnimation=2;
			else if(SDL_GetTicks()-this->startJump<400)
				this->_curAnimation=3;
			else if(SDL_GetTicks()-this->startJump<600)
				this->_curAnimation=4;
			else if(SDL_GetTicks()-this->startJump<900)
				this->_curAnimation=5;

		}
		if(this->_curAnimation==8 && (this->_curFrame==5 || this->_curFrame==6))
		{
			for(int i=2; i<mxPiece-mxAnimSoFar+1;i++)
			{
				if(!gp[i]->alive()) continue;

				if(this->_pos.distance(gp[i]->_pos+gp[0]->getOffset())<150)
				{
					if((this->_pos.x<gp[i]->_pos.x+gp[0]->getOffset().x && this->_direction==0) || (this->_pos.x>gp[i]->_pos.x+gp[0]->getOffset().x && this->_direction==1))
					{
						if((this->_curFrame==5 && this->_pos.y-25>gp[i]->_pos.y) || this->_pos.y>gp[i]->_pos.y)
							gp[i]->dmg();
						cout << endl << "I just killed Enemy (" << i << ")" << endl;
					}
				}
			}
		}

		// Modify as children
		if(this->_pos.x>575 || this->_pos.x<125)
		{
			this->_pos.x=this->_pos.x+this->_speed.x*-1;
			gp[0]->move(VECTOR(this->_speed.x*-1,0,1,2));
		}

		if(this->_pos.y>485)
			this->_pos.y=485;

		if(gp[0]->level()==0 && this->_pos.y<310)
			this->_pos.y=310;
		else if(gp[0]->level()==1 && this->_pos.y<150)
			this->_pos.y=150;

		// PANS THE LEVEL
		if(gp[0]->level()==0 && this->_pos.y>364 && this->_pos.y<376)
		{
			if(this->_speed.y>0)
				this->_targetHeight=this->_pos.y+12;//this->_pos.y=this->_pos.y+(this->_speed.y+12);
			else
				this->_targetHeight=this->_pos.y-12;//this->_pos.y=this->_pos.y+(this->_speed.y-12);
		}
		
		return false;
	}



	virtual void processKeys()
	{
		switch (event.type) 
		{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym) 
				{
					case SDLK_LEFT:
					case SDLK_KP4:
						this->_speed.x=-this->_speed.speed*(double)(SDL_GetTicks()-throttle)/1000;
						//cout << this->_speed.x << "<<<<" << endl;
						this->_direction=1;
						break;
					case SDLK_RIGHT:
					case SDLK_KP6:
						this->_speed.x=this->_speed.speed*(double)(SDL_GetTicks()-throttle)/1000;
						//cout << this->_speed.x << "<<<<" << endl;
						this->_direction=0;
						break;
					case SDLK_UP:
					case SDLK_KP8:
						this->_speed.y=-(this->_speed.speed/2)*(double)(SDL_GetTicks()-throttle)/1000;
						//this->groundY+=this->_speed.y;
      					break;
					case SDLK_SPACE:
						this->_curAnimation=8;
						this->_curFrame=0;
						break;
					case SDLK_LCTRL:
						if(jump) break;
							this->_targetHeight=200;
						jump=true;
						this->startJump=SDL_GetTicks();
						break;
      				case SDLK_DOWN:
					case SDLK_KP2:
      					this->_speed.y=this->_speed.speed*(double)(SDL_GetTicks()-throttle)/1000;
						//this->groundY+=this->_speed.y;
      					break;
					case SDLK_p:
						cout << "SCREEN: " << this->_pos.x << "," << this->_pos.y << endl;
						cout << "WORLD : " << this->_pos.x-gp[0]->getOffset().x << "," << this->_pos.y << endl;
						break;
					case SDLK_KP_PLUS:
						this->_speed.speed=2/(SDL_GetTicks()-throttle);
						break;
					case SDLK_KP_MINUS:
						this->_speed.speed=.5/(SDL_GetTicks()-throttle);
						if(this->_speed.speed<2) this->_speed.speed=4;
						break;
      				case SDLK_q:
      					exit(0);
      					break;
						/*
      				case SDLK_e:
      					state = GAME_STATE_QUIT;
      					break;
    				case SDLK_w:
      					state = GAME_STATE_WIN;
      					break;
    				case SDLK_l:
      					state = GAME_STATE_LOSE;
      					break;
						*/
      				default:
      					break;
    			}
				break;
			
			case SDL_KEYUP:
				switch( event.key.keysym.sym )
				{
    				case SDLK_LEFT:
					case SDLK_KP4:
      					this->_speed.x=0;
      					break;
    				case SDLK_RIGHT:
					case SDLK_KP6:
      					this->_speed.x=0;
      					break;
    				case SDLK_UP:
					case SDLK_KP8:
      					this->_speed.y=0;
      					break;
    				case SDLK_DOWN:
					case SDLK_KP2:
      					this->_speed.y=0;
      					break;
    				default:
      					break;
    			}
				break;
			

			case SDL_QUIT:
    			state = GAME_STATE_QUIT;
		}

		// this probably isn't the best way to do this, but its not my job
	
		// this probably isn't the best way to do this, but its not my job
		if(this->_speed.x==0 && this->_speed.y==0 && this->_curAnimation!=8)
			this->_curAnimation=1;
		else if(this->_curAnimation!=8)
			this->_curAnimation=0;	

		if(this->_speed.speed<5) this->_speed.speed=800;
	}


};

#endif