#ifndef __PLAYER_HPP__
#define __PLAYER_HPP__

#include "config.hpp"
#include "world.hpp"

class Player{
public:
	Player();
	~Player();

	void initialize();
	void update(World &board);
	void renderSDL(SDL_Surface *screen);

  double getRow() { return pos_r; }
  double getCol() { return pos_c; }

  void moveUp() { vel_r = -1; }
  void moveDown() { vel_r = 1; }
  void moveLeft() { vel_c = -1; }
  void moveRight() { vel_c = 1; }

  void stopUp() { if (vel_r < 0) vel_r = 0; }
  void stopDown() { if (vel_r > 0) vel_r = 0; }
  void stopLeft() { if (vel_c < 0) vel_c = 0; }
  void stopRight() { if (vel_c > 0) vel_c = 0; }

private:

	double pos_r;
	int vel_r;

	double pos_c;
	int vel_c;

	SDL_Surface *sprite;

};

#endif // __PLAYER_HPP__
