#ifndef _WORLD_H_
#define _WORLD_H_

class World  : public GamePiece
{
private:

	void _initialize()
	{
		offset=coord(0,0);
		this->initialize();
	}

public:
	coord offset;

	World()
	{
		this->_initialize();
		this->loadAnimation();
	}
	World(coord xy)
	{
		this->_initialize();
		this->loadAnimation();
		this->_pos=xy;
	}

	virtual coord getOffset()
	{
		return this->offset;
	}
	virtual void display()
	{
		SDL_Rect block;
		block.x = this->_pos.x;
		block.y = this->_pos.y;
		SDL_BlitSurface(this->_animation[0].sprite[this->_curFrame], NULL, screen, &block);

		block.x=10;
		block.y=514;
		SDL_BlitSurface(this->_animation[1].sprite[0], NULL, screen, &block);
	}

	virtual void move(VECTOR speed)
	{
		this->_pos=this->_pos+speed;
		this->offset=this->_pos;
		if(this->_pos.x>0)
			this->_pos.x=0;
		else if(this->_pos.x<-this->_animation[0].sprite[this->_curFrame]->w+803)
			this->_pos.x=-this->_animation[0].sprite[this->_curFrame]->w+803;
	}

	virtual int level()
	{	
		return this->_curFrame;
	}

	virtual void processKeys()
	{
		switch (event.type) 
		{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym) 
				{
					case SDLK_1:
						this->_curFrame=0;
						if(this->_pos.x<-this->_animation[0].sprite[this->_curFrame]->w+803)
							this->_pos.x=-this->_animation[0].sprite[this->_curFrame]->w+803;
						break;
					case SDLK_2:
						this->_curFrame=1;
						if(this->_pos.x<-this->_animation[0].sprite[this->_curFrame]->w+803)
							this->_pos.x=-this->_animation[0].sprite[this->_curFrame]->w+803;
						break;
      				default:
      					break;
    			}
				break;
			break;
		}

	}

	virtual bool loadAnimation()
	{
		this->_maxAnimation=2;
		this->_numFrames=new int[this->_maxAnimation];

		this->_numFrames[0]=2;


		this->_animation=new imgContainer[this->_maxAnimation];
		for(int _state=0; _state<this->_numFrames[_state]; _state++)
		{
			this->_animation[_state].sprite==new SDL_Surface*[this->_numFrames[_state]];
			this->_animation[_state].isCopy=false;
		}
		
		// This is hand coded but could be done automatically if the file names are indexed as well
		this->loadCell(0,0,CITY);
		this->loadCell(0,1,UNDERGROUND);
		this->loadCell(1,0,BAR);

		//this->_dim=dimension(this->_sprite[0][0]->w, this->_sprite[0][0]->h);
		
		//img->isCopy=false;
		return true;
	}
	virtual void UpdateAnimation()
	{
		return;
	}
};

#endif