#include "helper.hpp"

void display_bmp(char *file_name, SDL_Surface *screen)
{
  SDL_Surface *image;

  /* Load the BMP file into a surface */
  image = SDL_LoadBMP(file_name);
  if (image == NULL) {
    fprintf(stderr, "Couldn't load %s: %s\n", file_name, SDL_GetError());
    return;
  }

  /*
   * Palettized screen modes will have a default palette (a standard
   * 8*8*4 colour cube), but if the image is palettized as well we can
   * use that palette for a nicer colour matching
   */
  if (image->format->palette && screen->format->palette) {
    SDL_SetColors(screen, image->format->palette->colors, 0,
                  image->format->palette->ncolors);
  }

  /* Blit onto the screen surface */
  if(SDL_BlitSurface(image, NULL, screen, NULL) < 0)
    fprintf(stderr, "BlitSurface error: %s\n", SDL_GetError());

  //  SDL_UpdateRect(screen, 0, 0, image->w, image->h);

  /* Free the allocated BMP surface */
  SDL_FreeSurface(image);
}

/*
int setscreen(int width, int height, int depth, bool isfullscreen,
	      SDL_Surface *screen)
//sets the resolution of the new window,
//receives the width and height of the screen, e.g 1024,768 and the bit
//depth, plus a bool for whether to make it a fullscreen window and pointer to the surface to perform this all on.
{

  screen = SDL_SetVideoMode(width, height, depth,
			    SDL_HWSURFACE|SDL_ANYFORMAT);
  //create a screen as a window with the properties of a   hardware display
    if ( screen==NULL )
      {
	std::cout<<"Could not set video mode"<<width<<"x"<<height<<"x"<<depth<<"\n";
	return -1;
      }

  if ( isfullscreen == true )
    SDL_WM_ToggleFullScreen(screen);

  return 0;
}
//end of setscreen
*/
