#include "player.hpp"

Player::Player()
{
  pos_r = 50;
  pos_c = 50;
  vel_r = 0;
  vel_c = 0;
  sprite = NULL;
}

Player::~Player()
{
  SDL_FreeSurface(sprite);
}

void Player::initialize()
{
  SDL_Surface *temp;
  temp = SDL_LoadBMP("images/pacman.bmp");
  SDL_SetColorKey(temp, SDL_SRCCOLORKEY, 0);
  sprite = SDL_DisplayFormatAlpha(temp);
  SDL_SetColorKey(temp, 0, 0);
  SDL_FreeSurface(temp);
}

void Player::update(World &board)
{
  double posr2, posc2;
  double speed = 3.0;
  posr2 = pos_r+speed*vel_r;
  posc2 = pos_c+speed*vel_c;
  if (board.isFree(posr2, posc2)) {
    pos_r = posr2;
    pos_c = posc2;
  }

  board.eatPellet(pos_r, pos_c);
}

void Player::renderSDL(SDL_Surface *screen)
{
    //Draw PacMan
	SDL_Rect block;
    block.x = pos_c;
    block.y = pos_r;
    SDL_BlitSurface(sprite, NULL, screen, &block);
}
